/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <boost/assign/list_of.hpp>

#include "experiment_group.h"

using namespace TkResolver;
using namespace Experimenter;
using namespace Db::Ui;

const static NameList selection_columns = boost::assign::list_of(Name("name"));

ExperimentGroup:: ExperimentGroup(Db::Database * database)
  : DataSelectorCombo(database,
		      "experiment_group",
		      selection_columns)
{
  const static ComboColumnList display_columns = boost::assign::list_of
    (ComboColumnInfo("Group", selection_columns, 0));

  set_display_columns(display_columns);
}

TkString
ExperimentGroup:: get_experiment_group() const
{
  return std::string(get_selection().front()["name"]);
}
