/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_OPERATOR_SELECTOR_H__
#define __TK_EXP_OPERATOR_SELECTOR_H__

#include <gtkmm.h>

#include "libtkdbui/data_selector_list.h"

namespace TkResolver {
  namespace Experimenter {

    class OperatorInput : public Db::Ui::DataInput
      {
      private:
	Gtk::RadioButton              _male;
	Gtk::Calendar                 _date_of_birth;
	Gtk::CheckButton              _anonymous;
	Gtk::CheckButton              _send_results;
	Gtk::Entry                    _name;
	Gtk::Entry                    _place_of_birth;
	Gtk::Entry                    _email;
	Glib::RefPtr<Gtk::TextBuffer> _notes;

	void update_anonymity();
      protected:
	virtual Db::Parameters * get_data_sub();
      public:
	OperatorInput(Gtk::Window & parent);
      };

    class OperatorSelector : public Db::Ui::DataSelectorList<OperatorInput>
      {
      private:
	void render_operator_cell (Gtk::CellRenderer * renderer,
				      const Gtk::TreeModel::iterator iter);
      public:
	OperatorSelector(Db::Database * database,
			    Gtk::Window * parent);
	Db::IdList get_operators();

      };
    
  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_OPERATOR_SELECTOR_H__ */
