/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_PARAMETERS_H__
#define __TK_EXP_PARAMETERS_H__

#include <gtkmm.h>

#include "libtkcommon/tkstring.h"
#include "experiment_group.h"
#include "screen_size.h"
#include "randomness_source.h"

namespace TkResolver {
  namespace Experimenter {

    class Parameters : public Gtk::Frame
      {
      private:
	ExperimentGroup  _experiment_group;
	ScreenSize       _screen_size;
	RandomnessSource _randomness;
      public:
	Parameters(Db::Database * database);
	TkString get_experiment_group() const;
	unsigned get_width() const;
	unsigned get_height() const;
	void get_retriever_type(const TkString & experiment_group,
				TkString & retriever_type,
				bool & retriever_type_specified) const;
      };

  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_PARAMETERS_H__ */
