/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "libtkcommon/debug.h"
#include "libtkrandom/retriever_registry.h"
#include "randomness_source.h"

using namespace TkResolver;
using namespace Random;
using namespace Experimenter;

const Glib::ustring RandomnessSource::_chosen("[chosen]");

RandomnessSource:: RandomnessSource(Db::Database * database)
  : _database(database),
    _sources(RetrieverRegistry::get_names())
{
  append_text(_chosen);

  for (TkStringList::const_iterator iter = _sources.begin();
       iter != _sources.end();
       ++iter)
    {
      append_text(wstring_to_ustring(*iter));
    }
  
  property_active() = 0;
}

void
RandomnessSource:: get_randomness_source(const TkString & experiment_group,
					 TkString & source,
					 bool & specified) const
{ 
  Glib::ustring selection(get_active_text());
  if (selection != _chosen)
    {
      source = selection;
      specified = true;
      return;
    }

  source    = _database->choose_retriever(experiment_group, _sources);
  specified = false;
}
