/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_RANDOMNESS_SOURCE_H__
#define __TK_EXP_RANDOMNESS_SOURCE_H__

#include <gtkmm.h>

#include "libtkcommon/mbs.h"
#include "libtkdb/database.h"

namespace TkResolver {
  namespace Experimenter {

    class RandomnessSource : public Gtk::ComboBoxText
      {
      private:
	const static Glib::ustring _chosen;

	Db::Database * _database;
	TkStringList   _sources;
      public:
	RandomnessSource(Db::Database * database);
	void get_randomness_source(const TkString & experiment_group, TkString & source, bool & specified) const;
      };

  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_RANDOMNESS_SOURCE_H__ */
