/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_LIST_H__
#define __TK_DB_UI_DATA_SELECTOR_LIST_H__

#include <gtkmm.h>

#include "data_selector.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {

      class DataInput : public Gtk::Dialog
	{
	protected:
	  DataInput(const Glib::ustring & title, Gtk::Window & parent);
	  virtual Db::Parameters * get_data_sub() = 0;
	public:
	  Db::Parameters * get_data();
	};
      
      typedef Gtk::TreeViewColumn::SlotCellData SlotListCellData;
      typedef DisplayColumnInfo<SlotListCellData> ListColumnInfo;
      typedef std::list<ListColumnInfo> ListColumnList;
      typedef DisplayColumnAdaptor<Gtk::TreeViewColumn> ListColumnAdaptor;
      
      void append_selection(const Gtk::TreeModel::iterator & iter, ModelIteratorList * list);
      
      template<typename DI> class DataSelectorList : public DataSelector, public Gtk::Frame
	{
	private:
	  Gtk::Window *                         _parent;
	  Gtk::ScrolledWindow                   _view_scroll;
	  Gtk::TreeView                         _view;
	  
	  void input();
	  
	  void create_widgets(const ListColumnList & display_columns);
	protected:
	  
	  DataSelectorList(Db::Database * database,
			   const Name & table_name,
			   const NameList & selection_columns,
			   Gtk::Window * parent,
			   const Name & title);
	  // should be called immediately after constructor
	  void set_display_columns(const ListColumnList & display_columns);

	  Gtk::TreeView & get_view();
	  virtual ModelIteratorList get_selected() const;
	  virtual void refreshed();
	};

      #include "data_selector_list_impl.h"
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace TkResolver */




#endif /* __TK_DB_UI_DATA_SELECTOR_LIST_H__ */
