/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <iostream>
#include <stdexcept>
#include <string>

#include "sdl.h"

using namespace TkResolver;

SDL:: SDL()
{
  int err = SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER);
  if (err)
    {
      std::cerr << "could not initialise SDL: "
		<< SDL_GetError()
		<< std::endl;
      throw std::runtime_error(std::string("could not initialise SDL: ") + SDL_GetError());
    }

  atexit(SDL_Quit);
}

void
SDL:: reset()
{
  SDL_QuitSubSystem(SDL_INIT_VIDEO);
  
  int err = SDL_InitSubSystem(SDL_INIT_VIDEO);
  if (err)
    throw std::runtime_error(std::string("could not reinitialise SDL video: ") + SDL_GetError());
}
